#!/usr/bin/env python
# coding: utf-8

# In[1]:


#To Do
# add option to attache file(s) to shipment



import tkinter as tk
import tkinter.messagebox as box
from tkinter import filedialog
from tkinter import ttk
import itkdb
from glob import glob
import webbrowser
import json
import os


def shipping_interface():
    #global variables from function access

    #global variables from function access
    global client
    client = None

    
    app = tk.Toplevel()
    app.title('User Interface')

    
    
    #bring window to top and make active
    app.lift()
    app.focus_force()
    app.grab_set()
    app.grab_release()
        
    
    label_head = tk.Label(app, text='Shipping Interface', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    label_head.pack(padx = 10, pady = 10)
    
    
    
    
    #####Password verification
    
    
    frame_pw1 = tk.Frame(app)
    frame_pw1.pack(padx=10, pady=10)
    
    label_pw = tk.Label(frame_pw1, text='Please enter database passwords and press button first.'
                        , wraplength=300 ,width=50, justify='left', bg='yellow') 
    label_pw.grid(row=0, column=1, columnspan=2)
    
    
    label_pw1 = tk.Label(frame_pw1, text='Access Code 1: ')
    label_pw1.grid(sticky="w", row=1, column=1)
    pw1 = tk.StringVar()
    entry_pw1 = tk.Entry(frame_pw1, textvariable = pw1)
    entry_pw1['show'] = '*'
    entry_pw1.grid(sticky="w", row=1, column=2)

    label_pw2 = tk.Label(frame_pw1, text='Access Code 2: ')
    label_pw2.grid(sticky="w", row=2, column=1)
    pw2 = tk.StringVar()
    entry_pw2 = tk.Entry(frame_pw1, textvariable = pw2)
    entry_pw2['show'] = '*'
    entry_pw2.grid(sticky="w", row=2, column=2)
  
    


    def pw_read():
        global client
        db_password1 = pw1.get()
        db_password2 = pw2.get()
        if db_password1 and db_password2 :
            try:
                u = itkdb.core.User(access_code1=db_password1, access_code2=db_password2)
                client = itkdb.Client(user = u)
                client.user.authenticate()
                user = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database'".format(user["firstName"], user["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
                shipment_origin.set(user["institutions"][0]["code"])
            except Exception as e:
                print(e)
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'}) 
                pw_button.configure({'background': 'red'})
                client = None
        elif "ITKDB_ACCESS_CODE1" in os.environ and "ITKDB_ACCESS_CODE1" in os.environ:
            try: 
                client = itkdb.Client()
                client.user.authenticate()
                user = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database'".format(user["firstName"], user["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
                shipment_origin.set(user["institutions"][0]["code"])
            except Exception as e:
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'})
                pw_button.configure({'background': 'red'})
                client = None
        elif os.path.exists(".env"):
            try: 
                client = itkdb.Client()
                client.user.authenticate()
                dbUser = client.get('getUser', json={'userIdentity': client.user.identity})
                print( "Hello {} {}, \nwelcome to the ITk database".format(dbUser["firstName"], dbUser["lastName"]))
                entry_pw1.configure({'background': 'lime'})
                entry_pw2.configure({'background': 'lime'})
                label_pw.configure({'background': 'lightgrey'})
                pw_button.configure({'background': 'lime'})
            except Exception as e:
                box.showerror( 'Error', 'Wrong Passwords' )
                db_password1 = None
                db_password2 = None
                pw1.set('')
                pw2.set('')
                entry_pw1.configure({'background': 'red'})
                entry_pw2.configure({'background': 'red'})
                pw_button.configure({'background': 'red'})
                client = None
        else: 
            box.showwarning( 'Warning', 'Please Enter Passwords' )
            entry_pw1.configure({'background': 'yellow'})
            entry_pw2.configure({'background': 'yellow'}) 
            client = None

    pw_button = tk.Button(frame_pw1, text='Get Password', width=25, command = pw_read, bg='yellow' )
    pw_button.grid(row=3, column=1, columnspan=2)
    
    
    
    
    label_intro_text='Script for shipping items from users institute.    \nEither use single serial number of provide file with multiple serial numbers'
    label_intro = tk.Label(app, text=label_intro_text, wraplength=300 ,width=60, justify='left') 
    label_intro.pack(padx = 10, pady = 10)

    
    
   
    frame_input = tk.Frame(app)
    frame_input.pack(padx=10, pady=10)
    row_count = 0
    label_width = 20
    
    row_count += 1
    label_shipment_name = tk.Label(frame_input, text='Shipment Name: ', width = label_width, justify=tk.RIGHT, anchor="e")
    label_shipment_name.grid(row=row_count, column=1)
    shipment_name = tk.StringVar()
    entry_shipment_name = tk.Entry(frame_input, textvariable = shipment_name, width = 40)
    entry_shipment_name.grid(row=row_count, column=2, sticky=tk.W)
    
    
    
    row_count += 1
    label_shipment_origin = tk.Label(frame_input, text='Shipment Origin Institute: ', width = label_width, justify=tk.RIGHT, anchor="e")
    label_shipment_origin.grid(row=row_count, column=1)
    shipment_origin = tk.StringVar()
    entry_shipment_origin = tk.Entry(frame_input, textvariable = shipment_origin, width = 40, state=tk.DISABLED)
    entry_shipment_origin.grid(row=row_count, column=2, sticky=tk.W)
    
    
    
    recipients = {
        "Glasgow": 'GL',
        "Sheffield": 'SHF',
        "Birmingham": 'BHM',
        "Cambridge" : 'CAM',
        "RAL": 'RAL',
        "IHEP": 'IHEP',
        "Queen Mary" : 'QMUL',
        "CERN": 'CERN',
        "LBNL": 'LBNL_STRIP_MODULES',
        "UCSC(SCIPP) Modules": 'UCSC',
        "BNL": 'BNL',
        "Warwick": 'WARWICK',
        "TRIUMF": 'TRIUMF',
        "SFU": 'SFU',
        "Prague": 'Prague',
        "Toronto": 'UT',
        "Valencia": 'IFIC',
        "Freiburg": 'UNIFREIBURG',
        "DESY-Zeuthen": 'DESYZ',
        "DESY-Hamburg": 'DESYHH',
        "Pennsylvania": 'UPENN',
        "Dortmung": 'TUDO',
        "IFIC": 'IFIC',
        
    }
        
    row_count += 1
    label_shipment_recipient = tk.Label(frame_input, text='Shipment Recipient: ', width = label_width, justify=tk.RIGHT, anchor="e")
    label_shipment_recipient.grid(row=row_count, column=1)
    shipment_recipient = tk.StringVar()  
    entry_shipment_recipient = ttk.Combobox(frame_input, textvariable = shipment_recipient, width = 37, state="readonly")
    entry_shipment_recipient['values'] = list( recipients.keys() )
    entry_shipment_recipient.grid(row=row_count, column=2, sticky=tk.W)

    def recipient_trace(self, *args):
        if shipment_recipient.get() != '':
            print( f"Recipient Institute Code: {recipients[shipment_recipient.get()]}" )
    
    shipment_recipient.trace("w", recipient_trace)
    
    
    
    
    
    row_count += 1
    label_tracking = tk.Label(frame_input, text='Tracking Number: ', width = label_width, justify=tk.RIGHT, anchor="e")
    label_tracking.grid(row=row_count, column=1)
    tracking = tk.StringVar()
    entry_tracking = tk.Entry(frame_input, textvariable = tracking, width = 40)
    entry_tracking.grid(row=row_count, column=2, sticky=tk.W)
    
    
    
    row_count += 1
    label_shipping_service = tk.Label(frame_input, text='Shipping Service: ', width = label_width, justify=tk.RIGHT, anchor="e")
    label_shipping_service.grid(row=row_count, column=1)
    shipping_service = tk.StringVar()
    entry_shipping_service = tk.Entry(frame_input, textvariable = shipping_service, width = 40)
    entry_shipping_service.grid(row=row_count, column=2, sticky=tk.W)
    
    
    row_count += 1
    label_shipping_type = tk.Label(frame_input, text='Shipping Type: ', width = label_width, justify=tk.RIGHT, anchor="e")
    label_shipping_type.grid(row=row_count, column=1)
    shipping_type = tk.StringVar()
    #entry_shipping_type = tk.Entry(frame_input, textvariable = shipping_type, width = 30)
    entry_shipping_type = ttk.Combobox(frame_input, textvariable = shipping_type, width = 37, state="readonly")
    entry_shipping_type.grid(row=row_count, column=2, sticky=tk.W)
    entry_shipping_type['values'] = ("domestic", "intraContinental", "continental")
    
    
    row_count += 1
    label_comments = tk.Label(frame_input, text='Comments: ', width = label_width, justify=tk.RIGHT, anchor="e")
    label_comments.grid(row=row_count, column=1)
    comments = tk.StringVar()
    entry_comments = tk.Entry(frame_input, textvariable = comments, width = 40)
    entry_comments.grid(row=row_count, column=2, sticky=tk.W)
    
    
    
    
    
    
    
    
    
    
    frame_SN = tk.Frame(app)
    frame_SN.pack(padx = 10, pady = 10)
    
    compnameLabel = tk.Label(frame_SN, text='Component ID: ', width = 20, justify=tk.RIGHT, anchor="e" )
    compnameLabel.grid(row=0, column=1)
    componentName = tk.StringVar()
    compname = tk.Entry(frame_SN, textvariable = componentName, width = 40)
    compname.grid(row=0, column=2, columnspan=2, sticky=tk.W)
    compnameDescription = tk.Label(frame_SN, text='ATLAS ID or Alternative Identifier', width = 30, justify=tk.LEFT, anchor="w")
    compnameDescription.grid(row=1, column=2, columnspan=2, sticky=tk.W )
    
    
    altIdLabel = tk.Label(frame_SN, text='Alternative ID?', width = 20, justify=tk.RIGHT, anchor="e" )
    altIdLabel.grid(row=2, column=1)
    altID = tk.BooleanVar()
    radio_alt_no = tk.Radiobutton (frame_SN, text='False', variable = altID, value = False)
    radio_alt_yes = tk.Radiobutton (frame_SN, text='True', variable = altID, value = True)
    radio_alt_yes.select()
    radio_alt_yes.grid(row=2, column=2 )
    radio_alt_no.grid(row=2, column=3)
    
    
    
    
    
    
    #####Create Shipment
    
    
    #check that object exists
    #check that object is at user institute
    
    
    def get_component_code(serialNumber):
        if not client:
            print( 'Database access not possible, please enter passwords first and click on "Get Password".')
            box.showwarning( 'Warning', 'Please Get Passwords first.' )
            return
        
        print( f"Looking up component {serialNumber}")
        try:
            component = client.get('getComponent', json={"component":serialNumber, "alternativeIdentifier":altID.get()})
        except:
            box.showerror( 'Error', 'Component not found.' )
            print( 'Could not retrieve component information. Is the component name correct?' )
            if(altID.get()):
                print( f"Is {serialNumber} an alternative identifier?" )
            elif(altID.get()==False):
                print( f"Is {serialNumber} an ATLAS ID (or database id)?" )
            return None

        if component["currentLocation"]["code"] != shipment_origin.get():
            print( f"Component is not at Liverpool, it is at {component['currentLocation']['name']}" )
            return None
        if component["assembled"]:
            print( f"Component {serialNumber} is not the parent component.")
            print( f"Parent: {component['parents'][-1]['component']['serialNumber']} / {component['parents'][-1]['component']['alternativeIdentifier']}")
            return None
        if component["inTransit"]:
            print( f"Component {serialNumber} is already in transit")
            return None
        if component["shipmentDestination"]:
            print( f"Component {serialNumber} is already in a shipment" )
            return None
        
        #print(json.dumps(component, indent=3) )


        return component['code']
            
            
    
    
    
    
    def create_single_shipment():
        if not client:
            print( 'Database access not possible, please enter passwords first and click on "Get Password".')
            box.showwarning( 'Warning', 'Please Get Passwords first.' )
            return
        
        
        #check that minimum input is there
        if shipment_recipient.get() == '':
            print( "No Recipient chosen.")
            return
        if shipping_type.get() == '':
            print( "No shipment type chose.")
            return
        if componentName.get() == '':
            print( "No component for shipment chosen.")
            return
        
        shipment_item_name = get_component_code( componentName.get() )
        
        if not shipment_item_name:
            print("No Component to be shipped")
            return
        
        print( "Ship a single Object" )
        
        
        try:
            shipment = client.post('createShipment', json={
                                        'name': shipment_name.get() ,
                                        'sender': shipment_origin.get()  ,
                                        'recipient': recipients[shipment_recipient.get()],
                                        'trackingNumber': tracking.get() ,
                                        'shippingService': shipping_service.get(),
                                        'type': shipping_type.get() ,
                                        'shipmentItems': [ shipment_item_name ],
                                        'comments': [comments.get()]
                                    })
        except Exception as e:
            print(e)
            print( "Creating shipment failed.")
            return
        
        #print(json.dumps(shipment, indent=3) )
        
        print( f"Shipment Created: {shipment['id']}" )

        webaddress = "https://itkpd-test.unicorncollege.cz/shipmentView?id=" + shipment["id"]
        compWebName.set(webaddress)
        
        shipment_ID.set(shipment['id'])
        retrieve_button.configure({'background': 'green'})
        shipment_IDEntry.configure( {'state': tk.DISABLED} )
        
        
        
        

        
    
    
    def create_multiple_shipment():
        if not client:
            print( 'Database access not possible, please enter passwords first and click on "Get Password".')
            box.showwarning( 'Warning', 'Please Get Passwords first.' )
            return
        
        #check that minimum input is there
        if shipment_recipient.get() == '':
            print( "No Recipient chosen.")
            return
        if shipping_type.get() == '':
            print( "No shipment type chose.")
            return
        
        
        
        
        shipment_filename =  filedialog.askopenfilename(initialdir = "./",                                           title = "Select file",filetypes = (("text files","*.txt"),("all files","*.*")))
        
        shipment_items_list = []
        with open(shipment_filename) as file:
            for serial_number in file:
                single_item = get_component_code(serial_number.rstrip())
                #print(single_item)
                if single_item: shipment_items_list.append(single_item)
        #print(shipment_items_list)
        
        
        if not shipment_items_list:
            print("Nothing to be shipped")
            return
        
        
        print( "Ship multiple Objects" )
        
        try:
            shipment = client.post('createShipment', json={
                                        'name': shipment_name.get() ,
                                        'sender': shipment_origin.get()  ,
                                        'recipient': recipients[shipment_recipient.get()],
                                        'trackingNumber': tracking.get() ,
                                        'shippingService': shipping_service.get(),
                                        'type': shipping_type.get() ,
                                        'shipmentItems': shipment_items_list,
                                        'comments': [comments.get()]
                                    })
        except Exception as e:
            print(e)
            print( "Creating shipment failed.")
            return
        
        
        #print(json.dumps(shipment, indent=3) )
        
        print( f"Shipment Created: {shipment['id']}" )

        webaddress = "https://itkpd-test.unicorncollege.cz/shipmentView?id=" + shipment["id"]
        compWebName.set(webaddress)
        
        shipment_ID.set(shipment['id'])
        retrieve_button.configure({'background': 'green'})
        shipment_IDEntry.configure( {'state': tk.DISABLED} )
    
    
    
    
    
    frame_create_shipment = tk.Frame(app)
    frame_create_shipment.pack(padx = 10, pady = 10)  

    file_button = tk.Button(frame_create_shipment, text='Ship Single Object', width = 30, command = create_single_shipment )
    file_button.grid(row=1, column=1, pady=5 )

    dir_button = tk.Button(frame_create_shipment, text='Ship Multiple Objects from File', width = 30, command = create_multiple_shipment )
    dir_button.grid( row=1, column=2, pady=5)
    
   

    
    #####open shipment in website
    
    
    
    frame_webview = tk.Frame(app)
    frame_webview.pack(padx = 10, pady = 10) 
    compWebLabel = tk.Label(frame_webview, text='Shipment Website: ', width = 23, justify=tk.RIGHT, anchor="e"  )
    compWebLabel.grid(row=1, column=1)
    compWebName = tk.StringVar()
    compWeb = tk.Entry(frame_webview, textvariable = compWebName, width = 40)
    compWeb.grid(row=1, column=2, sticky=tk.W)
    
    
    def web_tab():
        webbrowser.open(compWebName.get(), new = 2)
    
    
    webTab_button = tk.Button(frame_webview, text='Open in Browser', width = 25, command=web_tab, bg='light blue')
    webTab_button.grid(row=2, column=2)
    
    
    
    
    
    
    
    
    
    
    
    #####Send Shipment
    
    
    frame_sending = tk.Frame(app)
    frame_sending.pack(padx=10, pady=10)
    
    
    shipment_IDLabel = tk.Label(frame_sending, text='Shipment ID: ', width = 23, justify=tk.RIGHT, anchor="e"  )
    shipment_IDLabel.grid(row=1, column=1)
    shipment_ID = tk.StringVar()
    shipment_IDEntry = tk.Entry(frame_sending, textvariable = shipment_ID, width = 40)
    shipment_IDEntry.grid(row=1, column=2, sticky=tk.W)
    
    
    def retrieve_shipment():
        if not client:
            print( 'Database access not possible, please enter passwords first and click on "Get Password".')
            box.showwarning( 'Warning', 'Please Get Passwords first.' )
            return
        
        print( f"Retrieving Shipment {shipment_ID.get()}")
        
        try:
            shipment = client.get('getShipment', json={"shipment":shipment_ID.get()})
        except:
            box.showerror( 'Error', 'Shipment not found.' )
            print( 'Could not retrieve shipment information. Shipment Name needs to be the mongoID of the shipment' )
            return
        
        webaddress = "https://itkpd-test.unicorncollege.cz/shipmentView?id=" + shipment["id"]
        compWebName.set(webaddress)
        
        print( "Shipment retrieved")
        
        #print(json.dumps(shipment, indent=3) )
    
    
    retrieve_button = tk.Button(frame_sending, text='Retrieve Shipment', width = 25, command=retrieve_shipment, bg='light blue')
    retrieve_button.grid(row=2, column=2)
    
    
    
    
    def send_shipment():
        if not client:
            print( 'Database access not possible, please enter passwords first and click on "Get Password".')
            box.showwarning( 'Warning', 'Please Get Passwords first.' )
            return
        
        if shipment_ID.get() =='':
            print( "No shipment selected to be send" )
            return
        
        
        print( f"Sending shipment {shipment_ID.get()}")
        
        shipment = client.get('getShipment', json={"shipment":shipment_ID.get()})
        
        #sending = client.post('updateShipment', json={
        #            'shipment': shipment["id"],
        #            'recipient': shipment["recipient"]["code"],
        #            'type': shipment["type"],
        #            'status': "inTransit"
        #        })
        
        try:
            sending = client.post('setShipmentStatus', json={
                            'shipment': shipment["id"],
                            'status' : "inTransit"
            })
        except Exception as e:
            print(e)
            print( "Sending shipment failed.")
            return
        
        
        #print(json.dumps(sending, indent=3) )
        print( "Shipment send." )
        clear()
    
    
    send_button = tk.Button(frame_sending, text='Send Shipment', width = 25, command=send_shipment)
    send_button.grid(row=3, column=2)
    
    
    
    #Clear for new shipment
    
    
    def clear():
        compWebName.set('')
        shipment_ID.set('')
        shipment_IDEntry.configure( {'state' : tk.NORMAL} )
        retrieve_button.configure({'background': 'light blue'})
        
        
        shipment_name.set('')
        shipment_recipient.set('')
        tracking.set('')
        shipping_service.set('')
        shipping_type.set('')
        comments.set('')
        componentName.set('')
        
        
        print("Clear all entries")
    
    
    clear_button = tk.Button(app, text='Clear', width=25, command=clear )
    clear_button.pack(padx = 10, pady = 10)
    

    
    def close_window():
        app.destroy()
        global db_password1, db_password2, client
        client = None
        db_password1 = None   #delete password when window is closed
        db_password2 = None   #delete password whwn window is closed


    exit_button = tk.Button(app, text='Close', width=25, command=close_window, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)
    
    
    
    
    app.mainloop()
    
    
    
    
    
if __name__ == "__main__":
    window = tk.Tk()
    #window.withdraw()
    
        
    quit_button = tk.Button(window, text='Close All', width=25, command=window.destroy, bg = 'red' )
    quit_button.pack(padx = 10, pady = 10)
    
    shipping_interface()


# In[ ]:




