#!/usr/bin/env python
# coding: utf-8

# In[5]:


import tkinter as tk
from tkinter import ttk
from tkinter import filedialog
import tkinter.messagebox as box
from glob import glob
from datetime import datetime, timezone, date
from tkcalendar import DateEntry
import json

def moduleglueweight_popup():
    
    
    
    
    app_VI = tk.Toplevel()
    
    #bring app_VIdow to top and make active
    app_VI.lift()
    app_VI.focus_force()
    app_VI.grab_set()
    app_VI.grab_release()
   
    app_VI.title('Module Glue Weight Interface')
    
    labelTitle = tk.Label(app_VI, text='Module Glue Weight', bg='blue', fg='white', font=('Arial Black', 12, 'bold'))
    labelTitle.pack(padx = 10, pady = 10)

    
    
    
    
    
    
    frame_line1 = tk.Frame(app_VI)
    frame_line1.pack()
    compnameLabel = tk.Label(frame_line1, text='Database ID: ', width = 15 )
    compnameLabel.pack(side = tk.LEFT, padx = 10, pady = 10)
    componentName = tk.StringVar()
    compname = tk.Entry(frame_line1, textvariable = componentName)
    compname.pack(side = tk.RIGHT, padx = 10, pady = 10)
    #componentName.trace('w', compname.configure({'background': 'white'}))
    
    def trace_feature(self, *args):
        compname.configure({'background': 'white'})
        gwCalculatedLabel.configure({'background': 'grey'})
        gwCalculated.set('')
        hType.set('')
        
        
    
    componentName.trace('w', trace_feature )
    
    
    frame_line2 = tk.Frame(app_VI)
    frame_line2.pack()
    altIdLabel = tk.Label(frame_line2, text='Alternative ID?', width = 15, justify=tk.RIGHT, anchor="e" )
    altIdLabel.pack( side=tk.LEFT, padx=10, pady=10)
    altID = tk.BooleanVar()
    radio_alt_no = tk.Radiobutton (frame_line2, text='False', variable = altID, value = False)
    radio_alt_yes = tk.Radiobutton (frame_line2, text='True', variable = altID, value = True)
    radio_alt_yes.select()
    radio_alt_no.pack( side = tk.RIGHT )
    radio_alt_yes.pack( side = tk.RIGHT )
    
    
    
    
    
    frame_line51 = tk.Frame(app_VI)
    frame_line51.pack()
    runNumberLabel = tk.Label(frame_line51, text='Run Number: ', width = 15, justify=tk.RIGHT, anchor="e" )
    runNumberLabel.pack( side=tk.LEFT, padx=10, pady=10 )
    runNumber = ttk.Combobox(frame_line51, width = 5)
    runNumber['values'] = ( '1',
                            '2',
                            '3',
                            '4',
                            '5',
                            '6',
                            '7',
                            '8',
                            '9',
                            '10')
    runNumber.pack( side=tk.RIGHT, padx=10, pady=10)
    runNumber.set('1')
    
    
    
    frame_Stencil = tk.Frame(app_VI)
    frame_Stencil.pack(padx=10, pady=10)
    
    hybridStencil1Label = tk.Label(frame_Stencil, text='Hybrid X Stencil: ', width = 25, justify=tk.RIGHT, anchor="e")
    hybridStencil1Label.grid(row=1, column=1)
    #hybridStencil1 = tk.StringVar()
    hybridStencil1Value = ttk.Combobox(frame_Stencil, width=20)
    hybridStencil1Value['values'] = ('RAL Prototype', '#012')
    hybridStencil1Value.current(0)
    hybridStencil1Value.grid(row=1, column=2)
    

    hybridStencil2Label = tk.Label(frame_Stencil, text='Hybrid Y Stencil: ', width = 25, justify=tk.RIGHT, anchor="e")
    hybridStencil2Label.grid(row=2, column=1)
    #hybridStencil2 = tk.StringVar()
    hybridStencil2Value = ttk.Combobox(frame_Stencil, width = 20)
    hybridStencil2Value['values'] = ('RAL Prototype', '#012')
    hybridStencil2Value.current(0)
    hybridStencil2Value.grid(row=2, column=2)
      
    
    pbStencilLabel = tk.Label(frame_Stencil, text='Powerboard Stencil: ', width = 25, justify=tk.RIGHT, anchor="e")
    pbStencilLabel.grid(row=3, column=1)
    #pbStencil = tk.StringVar()
    pbStencilValue = ttk.Combobox(frame_Stencil,width = 20)
    pbStencilValue['values'] = ('RAL Prototype', '#XXX')
    pbStencilValue.current(0)
    pbStencilValue.grid(row=3, column=2)
  
    
    
    
    
    
    
    frame_Weights = tk.Frame(app_VI)
    frame_Weights.pack(padx=20)
     
    carrierLable = tk.Label(frame_Weights, text='Module Carrier Weight [mg]: ', width = 25, justify=tk.RIGHT, anchor="e")
    carrierLable.grid(row=1, column=1)
    carrierWeight = tk.StringVar()
    carrierWeightValue = tk.Entry(frame_Weights, textvariable = carrierWeight, width = 10)
    carrierWeightValue.grid(row=1, column=2)
    
    sensorLable = tk.Label(frame_Weights, text='Sensor + Carrier Weight [mg]: ', width = 25, justify=tk.RIGHT, anchor="e")
    sensorLable.grid(row=2, column=1)
    sensorWeight = tk.StringVar()
    sensorWeightValue = tk.Entry(frame_Weights, textvariable = sensorWeight, width = 10)
    sensorWeightValue.grid(row=2, column=2)
    
    hybrid1Lable = tk.Label(frame_Weights, text='Hybrid X with Tab Weight [mg]: ', width = 25, justify=tk.RIGHT, anchor="e")
    hybrid1Lable.grid(row=3, column=1)
    hybrid1Weight = tk.StringVar()
    hybrid1WeightValue = tk.Entry(frame_Weights, textvariable = hybrid1Weight, width = 10)
    hybrid1WeightValue.grid(row=3, column=2)
    
    hybrid1TabLable = tk.Label(frame_Weights, text='Tab X Weight [mg]: ', width = 25, justify=tk.RIGHT, anchor="e")
    hybrid1TabLable.grid(row=3, column=3)
    hybrid1TabWeight = tk.StringVar()
    hybrid1TabWeightValue = tk.Entry(frame_Weights, textvariable = hybrid1TabWeight, width = 10)
    hybrid1TabWeightValue.grid(row=3, column=4)
    
    hybrid2Lable = tk.Label(frame_Weights, text='Hybrid Y with Tab Weight [mg]: ', width = 25, justify=tk.RIGHT, anchor="e")
    hybrid2Lable.grid(row=4, column=1)
    hybrid2Weight = tk.StringVar()
    hybrid2WeightValue = tk.Entry(frame_Weights, textvariable = hybrid2Weight, width = 10)
    hybrid2WeightValue.grid(row=4, column=2)
    
    hybrid2TabLable = tk.Label(frame_Weights, text='Tab Y Weight [mg]: ', width = 25, justify=tk.RIGHT, anchor="e")
    hybrid2TabLable.grid(row=4, column=3)
    hybrid2TabWeight = tk.StringVar()
    hybrid2TabWeightValue = tk.Entry(frame_Weights, textvariable = hybrid2TabWeight, width = 10)
    hybrid2TabWeightValue.grid(row=4, column=4)
    
    pbLable = tk.Label(frame_Weights, text='Powerboard Weight [mg]: ', width = 25, justify=tk.RIGHT, anchor="e")
    pbLable.grid(row=5, column=1)
    pbWeight = tk.StringVar()
    pbWeightValue = tk.Entry(frame_Weights, textvariable = pbWeight, width = 10)
    pbWeightValue.grid(row=5, column=2)
    
    moduleLable = tk.Label(frame_Weights, text='Module + Carrier Weight [mg]: ', width = 25, justify=tk.RIGHT, anchor="e")
    moduleLable.grid(row=6, column=1)
    moduleWeight = tk.StringVar()
    moduleWeightValue = tk.Entry(frame_Weights, textvariable = moduleWeight, width = 10)
    moduleWeightValue.grid(row=6, column=2)
    
    
    #Option for measurement date
    date_Label = tk.Label(frame_Weights, text='Measurement Date: ', width = 25, justify=tk.RIGHT, anchor="e")
    date_Label.grid(row=7, column=1)
    cal = DateEntry(frame_Weights, width=12, background='darkblue', maxdate=date.today(), 
                    foreground='white', borderwidth=2, dateformat=4, date_pattern='yyyy-mm-dd')
    cal.grid(row=7, column=2)
    
    
    
    
    calculatedLable = tk.Label(frame_Weights, text='Glue Weight [mg]: ', width = 25, justify=tk.RIGHT, anchor="e")
    calculatedLable.grid(row=8, column=1, pady=10)
    gwCalculated = tk.StringVar()
    gwCalculatedLabel = tk.Label(frame_Weights, textvariable=gwCalculated, width=10, bg='grey')
    gwCalculatedLabel.grid(row=8, column=2, pady=10)
    
    hType = tk.StringVar()
    hTypeLabel = tk.Label(frame_Weights, textvariable=hType, width=10, bg='grey')
    hTypeLabel.grid(row=8, column=3, pady=10)
    
        
    
    
    
    ##input measured weights
    
    ##calculate glue weight
    
    #pass/fail from calculated weight
    
    carrierWeight.set('')
    sensorWeight.set('')
    hybrid1Weight.set('')
    hybrid2Weight.set('')
    hybrid1TabWeight.set('')
    hybrid2TabWeight.set('')
    pbWeight.set('')
    moduleWeight.set('')
    
    
    
    
    frame_seepage = tk.Frame(app_VI)
    frame_seepage.pack()
    seepage_flagLabel = tk.Label(frame_seepage, text='Glue Seepage affecting bonding: ', width = 25 )
    seepage_flagLabel.pack( side=tk.LEFT, padx=10, pady=10)
    seepage_flag = tk.BooleanVar()
    seepage_flag_no = tk.Radiobutton (frame_seepage, text='No', variable = seepage_flag, value = False)
    seepage_flag_yes = tk.Radiobutton (frame_seepage, text='Yes', variable = seepage_flag, value = True)
    seepage_flag_no.select()
    seepage_flag_no.pack( side = tk.RIGHT )
    seepage_flag_yes.pack( side = tk.RIGHT )
    
    
    
    
    
    
    
  
    
    
    
    
    def get_save_directory():
        saveDirectory.set( filedialog.askdirectory(initialdir = "./",title = "Select Directory") )
        #print ( saveDirectory.get() )
    
    
    frame_line8 = tk.Frame(app_VI)
    frame_line8.pack()
    directoryLabel = tk.Label(frame_line8, text='Json saved in directory:', width=20)
    directoryLabel.pack(side = tk.LEFT, padx=10, pady=10)
    dir_button = tk.Button(frame_line8, text='Save Directory', width = 20, command = get_save_directory )
    dir_button.pack( side= tk.RIGHT, padx = 10, pady = 10)
    
    saveDirectory = tk.StringVar()
    saveDirLabel = tk.Label(app_VI, textvariable=saveDirectory, width=60, bg='grey', wraplength=350)
    saveDirLabel.pack(padx=10, pady=10)
    
    
    
    
    def create_json():
        print ( "Component Name: ", componentName.get() )
        
        
        if componentName.get()=='' or carrierWeight.get()=='' or sensorWeight.get()=='' or hybrid1Weight.get()==''             or hybrid1TabWeight.get()=='' or pbWeight.get()=='' or moduleWeight.get()=='' or saveDirectory.get()=='':
            box.showerror( 'Error', 'Please Complete all user fields and pick a save directory.' )
        else:

            
            #one or two hybrids
            if hybrid2Weight.get()!='' and hybrid2TabWeight.get()!='':
                hType.set('SS Module')
                gw_module = float(moduleWeight.get()) - float(sensorWeight.get())                     - float(hybrid1Weight.get()) + float(hybrid1TabWeight.get())                     - float(hybrid2Weight.get()) + float(hybrid2TabWeight.get())                     - float(pbWeight.get())
                
                gwCalculated.set( round(gw_module,2) )
                
                
                if seepage_flag.get() == True:
                    gwCalculatedLabel.configure({'background': 'red'})
                    passed = False
                    problems= False
                elif 338 <= gw_module <= 444:
                    gwCalculatedLabel.configure({'background': 'green'})
                    passed = True
                    problems= False
                elif gw_module < 338:
                    gwCalculatedLabel.configure({'background': 'red'})
                    passed = False
                    problems = False
                else:
                    gwCalculatedLabel.configure({'background': 'orange'})
                    passed = True
                    problems = True
                    
                    
                    
                    passed = False
                    problems = False
                
            else:
                hType.set('LS Module')
                gw_module = float(moduleWeight.get()) - float(sensorWeight.get())                     - float(hybrid1Weight.get()) + float(hybrid1TabWeight.get())                     - float(pbWeight.get())
                
                gwCalculated.set( round(gw_module,2) )
                if seepage_flag.get() == True:
                    gwCalculatedLabel.configure({'background': 'red'})
                    passed = False
                    problems= False
                elif 211 <= gw_module <= 277:
                    gwCalculatedLabel.configure({'background': 'green'})
                    passed = True
                    problems = False
                elif gw_module < 211:
                    gwCalculatedLabel.configure({'background': 'red'})
                    passed = False
                    problems = False
                else:
                    gwCalculatedLabel.configure({'background': 'orange'})
                    passed = True
                    problems = True
                
            
            #Measurement Date (using current time)
            datetimeobject = datetime.combine( cal.get_date(), datetime.now(timezone.utc).time() )
            
            
            out_dictionary = {}  ##dictionary for output
            out_dictionary.update({"componentType": "MODULE" }) 
            out_dictionary.update({"component": componentName.get() })             
            out_dictionary.update({"alternativeIdentifier": altID.get() })    
            out_dictionary.update({"currentStage": "GLUED" })        
            out_dictionary.update({"testType" : "GLUE_WEIGHT" })
            out_dictionary.update({"institution" : "LIV"})
            out_dictionary.update({"runNumber" : int( runNumber.get() ) })                           
            out_dictionary.update({"date" : datetimeobject.astimezone().isoformat(timespec='milliseconds')  })      
            out_dictionary.update({"passed" : passed })
            out_dictionary.update({"problems" : problems })
            out_dictionary.update({"properties": { 
                                        "GW_METHOD" : "stencil",
                                        "GLUE_METHOD_V_H1" : hybridStencil1Value.get(),
                                        "GLUE_METHOD_V_H2" : hybridStencil2Value.get(),
                                        "GLUE_METHOD_V_PB" : pbStencilValue.get()
                                    }})
            out_dictionary.update({"results" : {
                                        "GW_SENSOR" : ( float(sensorWeight.get()) - float(carrierWeight.get()) )/1000.0,  #sensor weight
                                        "GW_PB" : float( pbWeight.get() )/1000.0,  #powerboard weight
                                        "GW_HYBRID1T" : float( hybrid1Weight.get() )/1000.0, #weight hybrid1 with tabs
                                        "GW_T1" : float( hybrid1TabWeight.get() )/1000.0,    #weight tabs hybrid 1
                                    } })
            if hybrid2Weight.get()!='' and hybrid2TabWeight.get()!='':
                #SS module
                out_dictionary["results"].update({
                                        "GW_HYBRID2T" : float( hybrid2Weight.get() )/1000.0, #weight hybrid2 with tabs
                                        "GW_T2" : float( hybrid2TabWeight.get() )/1000.0,     #weight tabs hybrid 2
                                        "GW_MODULE_H1H2PB" : ( float(moduleWeight.get()) - float(carrierWeight.get()) )/1000.0, #weight module with 2 hybrids and PB
                                        "GW_GLUE_H1H2PB" : gw_module/1000.0    #weight glue 2 hybrids and PB
                                    } )
            else:
                #LS module
                out_dictionary["results"].update({
                                        "GW_MODULE_H1PB" : ( float(moduleWeight.get()) - float(carrierWeight.get()) )/1000.0,     #weight module with 1 hybrid and PB
                                        "GW_GLUE_H1PB" : gw_module/1000.0      #weight glue 1 hybrid and PB
                                    } )
                
            if seepage_flag.get() == True:
                out_dictionary.update({"comments" : ["Glue Seepage Affecting Wire Bonding."]    })

            
            
            
            
            #########save json file#######################################
    
            out_file_name = componentName.get() + '_GLUE_WEIGHT_' + runNumber.get()
            out_file = saveDirectory.get() +'\\' + out_file_name + '.json'
 
            print(f"Json output file: {out_file}")
            
            with open( out_file, 'w' ) as outfile:
                json.dump(out_dictionary, outfile, indent=4)  #indent makes it human readable
            
            
            compname.configure({'background': 'lime'})
            
            carrierWeight.set('')
            sensorWeight.set('')
            hybrid1Weight.set('')
            hybrid2Weight.set('')
            hybrid1TabWeight.set('')
            hybrid2TabWeight.set('')
            pbWeight.set('')
            moduleWeight.set('')
    
    
    def clear_fields():
        compname.delete(0,'end')
        runNumber.set('1')
        hType.set('')
        saveDirectory.set('')
        hybridStencil1Value.current(0)
        hybridStencil2Value.current(0)
        pbStencilValue.current(0)


    
    
    frame_button = tk.Frame(app_VI)
    frame_button.pack()
    create_button = tk.Button(frame_button, text='Create Json', width = 25, command=create_json)
    create_button.pack(side = tk.LEFT, padx = 10, pady = 10)
    clear_button = tk.Button(frame_button, text='Clear All', width = 25, command=clear_fields)
    clear_button.pack(side = tk.RIGHT, padx = 10, pady = 10)
    
    
    
    
    
    exit_button = tk.Button(app_VI, text='Close', width=25, command=app_VI.destroy, bg = 'red' )
    exit_button.pack(padx = 10, pady = 10)


    app_VI.mainloop()
    
    
    
    
if __name__ == "__main__":
    window = tk.Tk()
    #window.withdraw()
    
    quit_button = tk.Button(window, text='Close All', width=25, command=window.destroy, bg = 'red' )
    quit_button.pack(padx = 10, pady = 10)
    
    moduleglueweight_popup()
 


# {
# 	"componentType": "MODULE",
# 	"component": "20USBM00000002",
# 	"alternativeIdentifier": false,
# 	"currentStage": "GLUED",
# 	"testType": "GLUE_WEIGHT",
# 	"institution": "LIV",
# 	"runNumber": 1,
# 	"date": "2021-09-13T09:31:37.756+1:00",
# 	"passed": false,
# 	"problems": false,
# 	"properties" : {
# 		"GW_METHOD" : "stencil",
# 		"GLUE_METHOD_V_H1" : "Stencil Ver 1",
# 		"GLUE_METHOD_V_H2" : "Stencil Ver 1",
# 		"GLUE_METHOD_V_PB" : "Stencil Ver 5"
# 	},
# 	"results" : {
# 		"GW_SENSOR" : 1654.165,         #sensor weight
# 		"GW_PB" : 3212.3456,            #powerboard weight
# 		"GW_MODULE_H1PB" : 234.546,     #weight module with 1 hybrid and PB
# 		"GW_MODULE_H1H2PB" : 43590.234, #weight module with 2 hybrids and PB
#         "GW_GLUE_H1PB" : 234.6534,      #weight glue 1 hybrid and PB
#         "GW_GLUE_H1H2PB" : 234.6534,    #weight glue 2 hybrids and PB
# 		"GW_HYBRID1T" : 3495.547,       #weight hybrid1 with tabs
# 		"GW_HYBRID2T" : 20394.345,      #weight hybrid2 with tabs
# 		"GW_T1" : 30234.234,            #weight tabs hybrid 1
# 		"GW_T2" : 5324.234              #weight tabs hybrid 2
# 	}
# }
